<?php

namespace App\Mail\AdminMails;

use Illuminate\Mail\Mailable;
use Illuminate\Mail\Mailables\Attachment;
use Illuminate\Mail\Mailables\Content;
use Illuminate\Mail\Mailables\Envelope;

class CostUnitInvalidBillingDeadlineMail extends Mailable
{
    public function __construct(
        private int|string $costUnitId,
        private ?string    $costUnitName,
        private ?string    $invalidBillingDeadline,
    )
    {
        //
    }

    /**
     * Get the message envelope.
     */
    public function envelope(): Envelope
    {
        return new Envelope(
            subject: sprintf('Ungültiges Abrechnungsende für Kostenstelle #%s', $this->costUnitId),
        );
    }

    /**
     * Get the message content definition.
     */
    public function content(): Content
    {
        return new Content(
            view: 'emails.admin.cost_unit_invalid_billing_deadline',
            with: [
                'costUnitId' => $this->costUnitId,
                'costUnitName' => $this->costUnitName,
                'invalidBillingDeadline' => $this->invalidBillingDeadline,
            ],
        );
    }

    /**
     * Get the attachments for the message.
     *
     * @return array<int, Attachment>
     */
    public function attachments(): array
    {
        return [];
    }
}
